/*
	Copyright (c) 1995, 1996 Jeff Chua -- All Rights Reserved
*/

#include <stdio.h>		/* printf, sscanf */
#include <errno.h>		/* errno */
#include <sys/types.h>		/* open, read */
#include <sys/stat.h>		/* open */
#include <fcntl.h>		/* open */
#include <unistd.h>		/* read */
#include <string.h>		/* strstr */


#define Perror(s)		{ \
					if(errno == EINTR) \
						return 8; \
					printf("Line %d:  " \
						"%s:  Error %d:  %s\n", \
						__LINE__, s, errno, \
						sys_errlist[errno]); \
					exit(1); \
				}

			/* fields from /usr/src/linux/char/apm_bios.c */
			/* modified ... */
#define FORMAT		"%f %f %x %x %x %x %s %d %s\n"

#define POINTERS	&driver_version, \
			&apm_bios_info_version, \
			&apm_bios_info_flags, \
			&ac_line_status, \
			&battery_status, \
			&battery_flag, \
			percentage, \
			&time_units, \
			units


double	driver_version,
	apm_bios_info_version;

int	apm_bios_info_flags,
	ac_line_status,
	battery_status,
	battery_flag,
	time_units;

char	percentage[10],
	units[10];



int main(int argc, char *argv[])
{
	int fd, n;
	char buf[256], *p;
	char status[20], life[10];
	int count = 1;

	if((fd = open("/proc/apm", O_RDONLY)) == EOF)
		Perror("open");

	while(1) {
		switch(n = read(fd, buf, sizeof buf)) {
			case EINTR:
				printf("Interrupted!\n");
				exit(1);
			case 0:
				/* end of file */
				break;
			case EOF:
				Perror("read");
			default:
				switch(sscanf(buf, FORMAT, POINTERS)) {
					case 0:
						printf("invalid input "
							"character\n");
						exit(2);
					case EOF:
						Perror("sscanf");
					default:
						break;
				}

						

				if(count++ % 2)
					p = ac_line_status ?
						"Charging" : "Offline";
				else
					p = percentage;

				printf("\33" "7"
					"\33[0;70H"
					"\33[32m"
					"%10s"
					"\33[m"
					"\33[K"
					"\33" "8",
					p);

				fflush(stdout);

				break;
		}

		sleep(1);

		if(lseek(fd, 0, SEEK_SET) == EOF)
			Perror("lseek");
	}

}
